//
//	Exception
//

#ifndef		_EXCEPTION_INC_
#define		_EXCEPTION_INC_

class Exception
{
protected:
	Exception(const char *name, const char *desc, int line = 0)
		: name_(name), desc_(desc), line_(line)
	{
	}
public:
	Exception(const char *desc = "unknown", int line = 0)
		: name_("Exception"), desc_(desc), line_(line)
	{
	}
	operator const char * () const
	{
		return name_;
	}
	const char * name() const
	{
		return name_;
	}
	const char * desc() const
	{
		return desc_;
	}
	int          line() const
	{
		return line_;
	}
	virtual ~Exception()
	{
	}
protected:
	const char * name_;
	const char * desc_;
	int          line_;
};

#endif	//	_EXCEPTION_INC_
