//
//	PNG Definition
//

#ifndef		_PNGDEF_INC_
#define		_PNGDEF_INC_

#include "crc32.hpp"
#include "adler32.hpp"

namespace PNG
{
	typedef unsigned char  byte;
	typedef unsigned short word;
	typedef unsigned long  uint;
	
	const byte SIGNATURE[8] = { 0x89, 'P', 'N', 'G', '\r', '\n', 0x1A, '\n' };
	
	#pragma pack(1)
	struct IHDR
	{
		uint width;
		uint height;
		byte depth;
		byte color_type;
		enum
		{
			COLOR_GRAY = 0,
			COLOR_RGB  = 2,
			COLOR_PLTE = 3,
			COLOR_G_A  = 4,
			COLOR_RGBA = 6,
		};
		byte compression;
		byte filter;
		byte interlace;
	};
	struct PLTE
	{
		byte r, g, b;
	};
	
	struct Z_HDR
	{
		byte cmf, flg;
		enum Type
		{
			NO_COMPRESSION,
		};
		Z_HDR(Type type = NO_COMPRESSION)
		{
			switch (type) {
			case NO_COMPRESSION:
				cmf = 0x08, flg = 0x1D;
				break;
			}
		}
	};
	struct Z_BHDR
	{
		byte flg;
		word len, nlen;
		Z_BHDR(bool last = false, word n = 0)
			: flg(last ? 1 : 0), len(n), nlen(~n)
		{
		}
	};
	#pragma pack()
}

#endif	//	_PNGDEF_INC_
